#
# Example spec file for STAF
#

%define debug_package %{nil}

Summary: Software Testing Automation Framework
Name: staf
Version: 3.4.18
Release: 4%{?dist}
License: Eclipse Public License (EPL) V1.0
Group: Applications/Testing
Source: http://prdownloads.sourceforge.net/staf/STAF3418-src.tar.gz
Patch: linux-aarch64.patch
Patch1: dontCopySSL.patch
Patch2: staf-ipv6toipv4fallack.patch
URL: http://staf.sourceforge.net/
Distribution: IBM
Vendor: IBM
Packager: Bill Peck <bpeck@redhat.com>

BuildRequires: gcc-c++
BuildRequires: make
BuildRequires: openssl-devel
#BuildRequires: python-devel
BuildRequires: symlinks
#BuildRequires: java-1.5.0-gcj-devel
BuildRoot:	%{_topdir}/BUILDROOT/%{name}-%{version}-%{release}

%description
The Software Testing Automation Framework (STAF) is an open source, multi-platform, multi-language framework designed around the idea of reusable components, called services (such as process invocation, resource management, logging, and monitoring). STAF removes the tedium of building an automation infrastructure, thus enabling you to focus on building your automation solution. The STAF framework provides the foundation upon which to build higher level solutions, and provides a pluggable approach supported across a large variety of platforms and languages.


%prep
#%setup -n src/staf -c %{name}-%{version}
%setup -c
%patch -p1
%patch1 -p1
%patch2 -p1

%build
cd src/staf
# let's go and set a lot of environment vars (http://staf.sourceforge.net/current/stafdg.html)
export OPENSSL_ROOT=/usr
#if [ "%{?dist}" == ".el5" ]; then
#export OPENSSL_ROOT=/
#export OPENSSL_VERSION=0.9.8e
#elif [ "%{?dist}" == ".el4" ]; then
#export OPENSSL_ROOT=/
#export OPENSSL_VERSION=0.9.7a
#else
#export OPENSSL_VERSION=1.0.1k
#fi
if [ $RPM_ARCH == "i386" ]; then
    export OS_NAME=linux
elif [ $RPM_ARCH == "i686" ]; then
    export OS_NAME=linux
elif [ $RPM_ARCH == "aarch64" ]; then
    export OS_NAME=linux-aarch64
#    export OPENSSL_LIBDIRS=${OPENSSL_ROOT}/lib64
elif [ $RPM_ARCH == "s390x" ]; then
    export OS_NAME=zlinux
#    export OPENSSL_LIBDIRS=${OPENSSL_ROOT}/lib64
elif [ $RPM_ARCH == "s390" ]; then
    export OS_NAME=zlinux
elif [ $RPM_ARCH == "ppc" ]; then
    export OS_NAME=linux-ppc64-32
elif [ $RPM_ARCH == "ppc64" ]; then
    export OS_NAME=linux-ppc64-64
elif [ $RPM_ARCH == "ppc64le" ]; then
    export OS_NAME=linux-ppc64-64
#    export OPENSSL_LIBDIRS=${OPENSSL_ROOT}/lib64
elif [ $RPM_ARCH == "ia64" ]; then
    export OS_NAME=linuxia64
#    export OPENSSL_LIBDIRS=${OPENSSL_ROOT}/lib64
    if [ "%{?dist}" == ".el4" -o "%{?dist}" == ".el5" ]; then
        export OPENSSL_LIBDIRS=${OPENSSL_ROOT}/lib
    fi
elif [ $RPM_ARCH == "x86_64" ]; then
    export OS_NAME=linuxamd64
#    export OPENSSL_LIBDIRS=${OPENSSL_ROOT}/lib64
fi
export BUILD_TYPE=retail
#export PROJECTS="staf connprov* python java"
export PROJECTS="staf connprov*"
export STAF_USE_IPV6=1
make

%install
if [ $RPM_ARCH == "i386" ]; then
    OS_NAME=linux
elif [ $RPM_ARCH == "i686" ]; then
    OS_NAME=linux
elif [ $RPM_ARCH == "aarch64" ]; then
    OS_NAME=linux-aarch64
#    OPENSSL_LIBDIRS=${OPENSSL_ROOT}/lib64
elif [ $RPM_ARCH == "s390x" ]; then
    OS_NAME=zlinux
elif [ $RPM_ARCH == "s390" ]; then
    OS_NAME=zlinux
elif [ $RPM_ARCH == "ppc" ]; then
    OS_NAME=linux-ppc64-32
elif [ $RPM_ARCH == "ppc64" ]; then
    OS_NAME=linux-ppc64-64
#    OPENSSL_LIBDIRS=${OPENSSL_ROOT}/lib64
elif [ $RPM_ARCH == "ppc64le" ]; then
    OS_NAME=linux-ppc64-64
elif [ $RPM_ARCH == "ia64" ]; then
    OS_NAME=linuxia64
#    OPENSSL_LIBDIRS=${OPENSSL_ROOT}/lib64
elif [ $RPM_ARCH == "x86_64" ]; then
    OS_NAME=linuxamd64
#    OPENSSL_LIBDIRS=${OPENSSL_ROOT}/lib64
fi
pushd rel/${OS_NAME}/staf/retail/lib/
if [ ! -d "IPv6" ]; then mkdir IPv6; fi
cp libSTAF.so IPv6/.
cp libSTAFTCP.so IPv6/.
popd
pushd rel/${OS_NAME}/staf/retail/
#./STAFInst -target ${RPM_BUILD_ROOT}/opt/staf -bin ${RPM_BUILD_ROOT}/opt/staf/bin -lib ${RPM_BUILD_ROOT}/opt/staf/lib -option USE_PYTHON_VERSION=2.6 -acceptlicense -verbose
./STAFInst -target ${RPM_BUILD_ROOT}/opt/staf -bin ${RPM_BUILD_ROOT}/opt/staf/bin -lib ${RPM_BUILD_ROOT}/opt/staf/lib -acceptlicense -verbose -option TCP=IPV4_IPV6
symlinks -rcd ${RPM_BUILD_ROOT}/opt/staf
cd ${RPM_BUILD_ROOT}/opt/staf
for i in *.sh; do
    mv ${i} ${i}.old
    sed -e "s@${RPM_BUILD_ROOT}@@g" ${i}.old > ${i}
    rm -f ${i}.old
done
rm -f ${RPM_BUILD_ROOT}/opt/staf/STAFUninst

chmod 755 ${RPM_BUILD_ROOT}/opt/staf/startSTAFProc.sh
mkdir -p ${RPM_BUILD_ROOT}/etc/ld.so.conf.d/
echo "/opt/staf/lib/IPv6/" > ${RPM_BUILD_ROOT}/etc/ld.so.conf.d/STAF.conf
popd

%files
%attr (-, root, root) /opt/staf
%attr(644, root, root) /etc/ld.so.conf.d/STAF.conf

%clean
[ ${RPM_BUILD_ROOT} != "/" ] && rm -rf ${RPM_BUILD_ROOT}

%post
/sbin/ldconfig

%changelog
* Fri Apr 03 2015 - bpeck (at) redhat.com
- if ipv6 and ipv4 is configured allow ipv6 to fail
- don't bundle openssl

* Wed Aug 27 2014 - bpeck (at) redhat.com
- Updated to latest version
* Fri May 18 2012 - guandalf (at) gmail.com
- Added ld.so.conf.d configuration
